## Measurements

This report was generated with the measure-analysis.py script.
JSON formated measures were imported in the measures folder using the import functionnality of the script, this report was then generated using these measures.
Metadata is included with the measures, such as the kernel version used, the boot parameters passed, various others parameters specific to the measure, etc... 
Measures measuring the same propriety are grouped together in tables and graphs, and are identified by their diverging metadatas. This is useful to analyse the effect of specific parameters on the  measured propriety.

 Currently, most of the measures need to be redone, as the code for sending the packets has changed and gave different results.

### Description of the metadata associated to each test

* **ker**: Linux kernel version used
* **prio**: Priority of the real-time thread
* **i**: Interval between each packet transmission
* **boot_p**: Boot Parameters passed to u-boot
* **delta**: ETF qdisc delta value
* **load**: External device and processor load during the test
* **duration**: Duration of the test
* **etf_offset**: When a packet's txtime is scheduled, the txtime set is the current time offset by etf_offset
* **route**: How the boards are connected. 'switch' means they are connected by a switch (cheap, unmanaged), 'E2E'means they are directly connected end to end

### cyclictest_wake-up_latency results

Uses cyclictest from the rt-tests test suite to measure wake-up latency. A real-time thread is run on CPU1, and wakes up at a regular interval (specified by the interval parameter) using clock_nanosleep. It then uses clock_gettime and computes the difference between the scheduled wake-up time and the effective wake-up time measured by clock_gettime. The command used is: cyclictest -p `prio` -a1 -t1 -n -h 200 -q -i `interval`

**Common test metadata:** Boot Parameters: isolcpus, Task priority: 99, qdisc: pfifo_fast, etf_offset: none, route: switch, Ethernet speed in Mb/s: 100

Metadata                                                | Minimum             | Maximum             | Average             | Standard deviation 
------------------------------------------------------- | ------------------- | ------------------- | ------------------- | -------------------
**duration, ker, i, delta, load**                       | **wake-up latency** | **wake-up latency** | **wake-up latency** | **wake-up latency**
21h22, 4.19-debian, 200us, 200us, hackbench (384614861) | 14.0000us           | 112.0000us          | 19.5352us           | 2.0136us           
70h32, 4.19-debian, 200us, 200us, hackbench (1269804578) | 14.0000us           | 72.0000us           | 20.5580us           | 1.9820us           
70h55, 4.19-custom, 1000us, none, hackbench (255351482) | 18.0000us           | 161.0000us          | 39.0534us           | 7.5994us           
42h56, 4.19-custom, 1000us, none, ssh (154595654)       | 15.0000us           | 176.0000us          | 19.0966us           | 1.6605us           
42h56, 4.19-debian, 1000us, none, ssh (154592878)       | 13.0000us           | 140.0000us          | 17.0746us           | 0.8506us           
42h56, 5.6-custom, 1000us, none, ssh (154584616)        | 20.0000us           | 140.0000us          | 24.1787us           | 1.3821us           
0h14, 5-6-custom-2, 200us, none, hackbench (4478059)    | 19.0000us           | 135.0000us          | 25.1931us           | 4.2568us           
0h16, 4.19-custom-2, 200us, none, hackbench (5065578)   | 16.0000us           | 71.0000us           | 22.7266us           | 4.0622us           
0h17, 4.19-debian, 200us, none, hackbench (5314694)     | 15.0000us           | 70.0000us           | 23.1271us           | 4.2610us           
16h10, 5.6-custom-2, 1000us, none, ssh (58208576)       | 19.0000us           | 122.0000us          | 20.8207us           | 0.6878us           
16h10, 5.6-custom-2, 1000us, none, ssh (58211241)       | 19.0000us           | 118.0000us          | 20.8659us           | 0.7242us           
16h10, 4.19-debian, 1000us, none, ssh (58203179)        | 14.0000us           | 121.0000us          | 17.9607us           | 1.8142us           

![alt text](measures/graphs/cyclictest_wake-up_latencywake-up latency.png "cyclictest_wake-up_latency Graph")

### packet_rtt results

An UDP packet is periodically sent from one board to another and sent back as soon as it arrives using a real time thread. The round trip time is computed with clock_gettime on the transmitting board.

**Common test metadata:** Linux kernel version: 4.19-debian, Boot Parameters: isolcpus, Interval: 10000us, ETF qdisc delta: 200us, Task priority: 99, Device and processor load: ssh, Test duration: 0h4, qdisc: pfifo_fast, etf_offset: none, route: switch, Ethernet speed in Mb/s: 100

Minimum    | Maximum    | Average    | Standard deviation | Lost packets
---------- | ---------- | ---------- | ------------------ | ------------
**rtt**    | **rtt**    | **rtt**    | **rtt**            |             
636.0000us | 972.0000us | 674.0051us | 15.5468us          | 0           

![alt text](measures/graphs/packet_rttrtt.png "packet_rtt Graph")

### packet_jitter results

An UDP packet is periodically sent from one board to another using a real time thread. The receiving board calculates the intervals between the packets it receives, and sees how much it differs from the scheduled interval.

**Common test metadata:** Boot Parameters: isolcpus, Interval: 1000us, Task priority: 99

Metadata                                                              | Minimum     | Maximum    | Average    | Standard deviation | Lost packets
--------------------------------------------------------------------- | ----------- | ---------- | ---------- | ------------------ | ------------
**delta, duration, qdisc, etf_offset, ker, route, speed, load**       | **jitter**  | **jitter** | **jitter** | **jitter**         |             
none, 0h51, pfifo_fast, none, 4.19-debian, switch, 100, ssh (3077562) | -324.0000us | 162.0000us | 8.5575us   | 13.0667us          | 0           
160us, 16h43, etf, 600us, 5.6-custom, switch, 100, ssh (60200401)     | -500.0000us | 483.0000us | 5.2553us   | 8.1791us           | 0           
160us, 16h38, etf, 600us, 4.19-custom, switch, 100, ssh (59917045)    | -382.0000us | 248.0000us | 5.7003us   | 8.3437us           | 0           
160us, 0h5, etf, 500us, 4.19-debian, E2E, 1000, ssh (300154)          | -167.0000us | 178.0000us | 8.1353us   | 11.0959us          | 0           
160us, 0h5, etf, 500us, 4.19-debian, E2E, 100, ssh (317272)           | -172.0000us | 161.0000us | 10.6352us  | 13.5693us          | 0           
160us, 0h42, etf, 500us, 4.19-debian, E2E, 100, ssh (2553803)         | -190.0000us | 215.0000us | 9.2664us   | 12.0520us          | 0           
160us, 0h1, etf, 600us, 5.6-custom, E2E, 1000, none (100174)          | -141.0000us | 138.0000us | 3.5472us   | 6.4712us           | 0           
none, 16h8, pfifo_fast, none, 5.6-custom, E2E, 1000, none (58081333)  | -267.0000us | 306.0000us | 8.0829us   | 12.0204us          | 0           
160us, 1h4, etf, 600, 4.19-debian, E2E, 1000, ssh (3846039)           | -206.0000us | 230.0000us | 9.4174us   | 12.1711us          | 3           
160us, 16h18, etf, 500us, 4.19-debian, switch, 100, ssh (58719959)    | -198.0000us | 182.0000us | 10.5478us  | 13.0301us          | 7           
none, 1h11, pfifo_fast, none, 4.19-debian, E2E, 1000, ssh (4295445)   | -301.0000us | 204.0000us | 7.0618us   | 10.0641us          | 7           

![alt text](measures/graphs/packet_jitterjitter.png "packet_jitter Graph")

### packet_recv_timestamps results

An UDP packet is periodically sent from one board to another using a real time thread. The receiving board uses the SO_TIMESTAMPING option to see when the packet entered the kernel, and generates timestamps with clock_gettime once the packets enters userspace to compute the time the packet spent in kernel space.

**Common test metadata:** Linux kernel version: 4.19-debian, Boot Parameters: isolcpus, Interval: 1000us, ETF qdisc delta: 160us, Task priority: 99, Device and processor load: ssh, Test duration: 0h59, qdisc: etf, etf_offset: 600us, route: switch, Ethernet speed in Mb/s: 100

Minimum          | Maximum          | Average          | Standard deviation | Lost packets
---------------- | ---------------- | ---------------- | ------------------ | ------------
**kernel_space** | **kernel_space** | **kernel_space** | **kernel_space**   |             
34.0000us        | 189.0000us       | 39.9677us        | 4.1425us           | 0           

![alt text](measures/graphs/packet_recv_timestampskernel_space.png "packet_recv_timestamps Graph")


